#!/usr/bin/env nix-shell
#!nix-shell -i python -p python3


import sys
import time
import struct
from socket import *


if len(sys.argv) < 2:
  print(f'Usage: {sys.argv[0]} HOST')
  exit(1)


port = 4213
host = sys.argv[1]
print(f'Using host[ {host} ]')


class CyanBusInjector:

  BreakHeader  = b'[CyanBusBreak]'
  PacketHeader = b'[CyanBusPacket]'

  def __init__(self, host: str, port: int = 4213):
    self.socket = socket(AF_INET, SOCK_DGRAM)

    print(f'Starting CyanBusInjector{"{"} host[ {host} ]  port[ {port} ] {"}"}')

  def sendRaw(self, data: bytes):
    try:
      self.socket.sendto(data, (host, port))
    except:
      pass

  def sendPacket(self, payload: bytes, _break: bool = False):

    if _break: header = self.BreakHeader
    else:      header = self.PacketHeader

    packet = header + payload
    self.sendRaw(data=packet)


if __name__ == '__main__':
  
  if len(sys.argv) <= 2:
    sys.exit(0)

  payload = sys.argv[2]


  cbInjector = CyanBusInjector(host)

  while True:
    cbInjector.sendPacket(payload=payload.encode('UTF-8'), _break=False)
    time.sleep(0.05)

